/************************************************************************************
* Copyright (C) 1997 Charles-Edouard Ruault ce@ruault.com
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************************************************************************************/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import News.*;

public class HeaderViewer extends JFrame implements ActionListener
{
	private JMenuBar Bar;
	private JTextArea txt;
	private JMenu M1;

	public HeaderViewer(String id)
	{
		super("Header : "+id);

		addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e)
            {
                setVisible(false);
            }
        });

		JPanel P=new JPanel();
		GridBagLayout grid=new GridBagLayout();
		GridBagConstraints c=new GridBagConstraints();
		P.setLayout(grid);

		c.weightx=1;
		c.weighty=1;
		c.gridwidth=GridBagConstraints.REMAINDER;
		c.fill=GridBagConstraints.BOTH;
		txt=new JTextArea(15, 60);
		txt.setEditable(false);
		grid.setConstraints(txt, c);
		P.add(txt);

		Bar=new JMenuBar();
		M1=new JMenu("Window");
		JMenuItem jmi;
		M1.add(jmi=new JMenuItem("Close"));
		jmi.addActionListener(this);
		Bar.add(M1);
		setJMenuBar(Bar);
		getContentPane().add("Center", P);
		pack();
	}

	public void setArticle(NewsArticle cur)
	{

		setTitle("Header : "+cur.getID());
		txt.setText(cur.getHeader());
	}

	public void clearText()
	{

		setTitle(" ");
		txt.setText("");
	}

	public void actionPerformed(ActionEvent e)
	{

		if (e.getSource() instanceof JMenuItem)
		{
			if (e.getActionCommand().equals("Close"))
			{
				setVisible(false);
			}
		}
	}
}
