/************************************************************************************
* Copyright (C) 1997 Charles-Edouard Ruault ce@ruault.com
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************************************************************************************/
package Mail;
import java.lang.*;
import java.util.*;
import utils.Result;
import java.io.IOException;
import Mail.Mailer;

public class MailMessage extends Observable implements Runnable
{
	private MailAddress To, From;
	private String Header, Body, Host;
	private int Port;
	private Thread sender;
	
	private boolean SetFrom()
	{
		int beg, end;

		beg=Header.indexOf("From: ");
		if (beg == -1)
		{
			System.out.println("From not found in : \n"+Header);
			return false;
		}
		end=Header.indexOf('\n', beg);
		if (end == -1)
		{
			System.out.println("Bad From line in : \n"+Header);
			return false;
		}
		From=new MailAddress(Header.substring(beg+6, end));
		return true;
	}

	private boolean SetTo()
	{
		int beg, end;

		beg=Header.indexOf("To: ");
		if (beg == -1)
		{
			System.out.println("To not found in : \n"+Header);
			return false;
		}
		end=Header.indexOf('\n', beg);
		if (end == -1)
		{
			System.out.println("Bad To line in : \n"+Header);
			return false;
		}
		To=new MailAddress(Header.substring(beg+4, end));
		return true;
	}

	public MailMessage(String MailHost, String MailPort, String header, String body)
	{

		Header=header;
		Body=body;
		if (SetTo()==false)
		{
			System.out.println("SetTo failed : \n"+Header);
			return;
		}
		if (SetFrom()==false)
		{
			System.out.println("SetFrom failed : \n"+Header);
			return;
		}

		Host=MailHost;
		Port=(new Integer(MailPort)).intValue();
	}

	public MailAddress getSender()
	{

		return From;
	}

	public MailAddress getReceiver()
	{

		return To;
	}

	public String getHeader()
	{

		return Header;
	}

	public String getBody()
	{

		return Body;
	}

	public void Send() 
	{
		sender=new Thread(this, "Mail sender");
		sender.start();
	}

	public void cancel()
	{
	}
	
	public void run()
	{
		boolean sent=false;
		String msg="";
		
		try
		{
			//System.out.println("sending mail");
			Mailer mailer=new Mailer(this, Host, Port);
			mailer.Send();
			sent=true;
			//System.out.println("ok");
		}
		catch (IOException io)
		{
			io.printStackTrace();
			msg=io.getMessage();
		}
		catch (SmtpException smtp)
		{
			smtp.printStackTrace();
			msg=smtp.getMessage();
		}
		setChanged();
		notifyObservers(new Result(sent, msg));
	}
}






