/************************************************************************************
* Copyright (C) 1997 Charles-Edouard Ruault ce@ruault.com
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
************************************************************************************/
package News;
import java.lang.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class JNewsProps extends Properties
{
	private String File;

	public JNewsProps(String filename)
	{
		super();

		String Host;
		InetAddress addr;

		try
		{
			addr=InetAddress.getLocalHost();
			Host=addr.getHostName();
		}
		catch (UnknownHostException ex)
		{
			System.out.println("Unable to get local hostname : "+ex.getMessage());
			Host="";
		}
		File=new String(filename);

		put("NntpHost", Host);
		put("NntpPort", "119");
		put("SmtpHost", Host);
		put("SmtpPort", "25");
		put("Name", "");
		put("EMail", "");
		put("Organization", "");
		put("Signature", "");
		this.LoadProps();
		put("Version", "1 Alpha 4");
	}

	public void LoadProps()
	{
		FileInputStream Fi;

		try
		{
		    Fi=new FileInputStream(File);
		}
		catch (FileNotFoundException ex)
		{
			System.out.println("Error Opening resources file : "+ex.getMessage());
			return;
		}
		try
		{
			super.load(Fi);
		}
		catch (IOException ex)
		{
			System.out.println("Error loading resources : "+ex.getMessage());
		}
	}

	public boolean SaveProps()
	{
		FileOutputStream Fo;

		try
		{
			Fo=new FileOutputStream(File);
		}
		catch (IOException ex)
		{
			System.out.println("Error Opening resources file : "+ex.getMessage());
			return false;
		}
		super.save(Fo, "JavaNews resources V1.0");
		return true;
	}
}
